//		Statistics for Dynamic & Static Networks
//		Chris Briglio


#include "stdafx.h"


//------------------------------------------------------------------------------MAIN PROGRAM-----------------------------------------------------------------------------------------//

//-----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------//


using namespace std;


/*
	main:
		Program HUB. Serves as title screen and access point for
		all aspects of Statistics for Dynamic & Static Networks Program.
*/
int main(int argc, char* argv[])
{
    
 //------------------------------------------------------------------------------VARIABLES--------------------------------------------------------------------------------------------//

 //-----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------//

	bool title = true;

	string input = "";

	string fileInput = "";
 //------------------------------------------------------------------------------TITLE SCREEN-----------------------------------------------------------------------------------------//

 //-----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------//
	if(argc != 2)															//no parameter/more than 1 parameter given
	{
		cout << "Please enter the name of the input command file." << endl;
		getline(cin, fileInput);
	}
	else
	{
		fileInput = argv[1];												//input file was given using a command line parameter, get the filename of the input file
	}

	ifstream commands;
	commands.open(fileInput);
	commands >> input;
	getline(commands, infilename);
	getline(commands, infilename);
	/*do		//do-while loop for title screen							//old UI code
	{
		
		cout << "\n";
		cout << "\t***********************************************\n";
		cout << "\t*                                             *\n";
		cout << "\t*   Statistics for Dynamic & Static Networks  *\n";
		cout << "\t*                                             *\n";
		cout << "\t*                                             *\n";
		cout << "\t*                Options:                     *\n";
		cout << "\t*                                             *\n";
		cout << "\t*           1. Location Generator             *\n";
		cout << "\t*                                             *\n";
		cout << "\t*           2. Dynamic Statistics             *\n";
		cout << "\t*                                             *\n";
		cout << "\t*           3. Static Statistics              *\n";
		cout << "\t*                                             *\n";
		cout << "\t*           4. Statistics Summary             *\n";
		cout << "\t*                                             *\n";
		cout << "\t*           5. Spreadsheet Creator            *\n";
		cout << "\t*                                             *\n";
		cout << "\t*           6. View Statistics in MATLAB      *\n";
		cout << "\t*                                             *\n";
		cout << "\t*           7. Full Statistical Run Through   *\n";
		cout << "\t*                                             *\n";
		cout << "\t*           8. Exit                           *\n";
		cout << "\t*                                             *\n";
		cout << "\t***********************************************\n";
		cout << "\n\n";
          
		cout << "\t                >> "; getline(cin,input);
          
		boost::to_upper(input);
       */
	if (input == "1")
	{
		system("CLS");
		double temp_ref;
		double temp_trans;
		commands >> temp_ref;
		commands >> temp_trans;
		commands >> input;
		bool run;
		if(input == "true")
			run = true;
		else
			run = false;
		commands >> input;
		extension = input;
		commands >> input;
		double temp_run;
		commands >> temp_run;
		int tempX, tempY;
		commands >> tempX;
		commands >> tempY;
		LocationGenerator(run, temp_trans, temp_ref, input, temp_run, tempX, tempY);
		system("CLS");
	}
	else if (input == "2")
	{
		system("CLS");
		int runtime;
		commands >> runtime;
		commands >> input;
		if(input == "true")
		{
			int graphTime;
			commands >> graphTime;
			DynamicStatistics(runtime,false, true, graphTime);
		}
		else
			DynamicStatistics(runtime, false, false, 0);
		system("CLS");
	}
	else if (input == "3")
	{
		system("CLS");
		commands >> input;
		int range;
		commands >> range;
		bool graph;
		if(input == "true")
		{
			graph = true;
		}
		else
		{
			graph = false;
		}
		commands >> input;
		extension = input;
		commands >> input;
		if(input == "single")
			StaticStatistics(range, graph, true);
		else if(input == "multiple")
			StaticStatistics(range, graph, false);
		system("CLS");
	}
	else if (input == "4")
	{
			/*system("CLS");
			do
			{
				
				cout << "\n";
				cout << "\t***********************************************\n";
				cout << "\t*                                             *\n";
				cout << "\t*   Statistics for Dynamic & Static Networks  *\n";
				cout << "\t*                                             *\n";
				cout << "\t*                                             *\n";
				cout << "\t*                Options:                     *\n";
				cout << "\t*                                             *\n";
				cout << "\t*           1. Static Statistics Summary      *\n";
				cout << "\t*                                             *\n";
				cout << "\t*           2. Dynamic Statistics Summary     *\n";
				cout << "\t*                                             *\n";
				cout << "\t*           3. Exit                           *\n";
				cout << "\t*                                             *\n";
				cout << "\t*                                             *\n";
				cout << "\t***********************************************\n";
				cout << "\n\n";
          
				cout << "\t                >> "; getline(cin,input);

				boost::to_upper(input);

				if (input != "1" && input != "2" && input != "3" && input != "EXIT")
				{
					system("CLS");
					output_file << "Please choose a valid option\n";
				}

			}while(input != "1" && input != "2" && input != "3" && input != "EXIT");

			system("CLS");
			*/
		string sequence;
		getline(commands, sequence);
		commands >> extension;
		if (extension == ".txt")
			filetype = "NS2";
		if (extension == ".xml")
			filetype = "OPNET";
		if (extension == ".imn")
			filetype = "CORE";
		commands >> input;
		if (input == "Static")
			StatisticsSummary_STATIC(sequence);
		else if (input == "Dynamic")
		{
			double run_time;
			commands >> run_time;
			StatisticsSummary(sequence, run_time);
		}
			//system("CLS");
	}
	else if (input == "5")
	{
			/*system("CLS");
			do
			{
				
				cout << "\n";
				cout << "\t***********************************************\n";
				cout << "\t*                                             *\n";
				cout << "\t*   Statistics for Dynamic & Static Networks  *\n";
				cout << "\t*                                             *\n";
				cout << "\t*                                             *\n";
				cout << "\t*                Options:                     *\n";
				cout << "\t*                                             *\n";
				cout << "\t*           1. Static Statistics Spreadsheet  *\n";
				cout << "\t*                                             *\n";
				cout << "\t*           2. Dynamic Statistics Spreadsheet *\n";
				cout << "\t*                                             *\n";
				cout << "\t*           3. Exit                           *\n";
				cout << "\t*                                             *\n";
				cout << "\t*                                             *\n";
				cout << "\t***********************************************\n";
				cout << "\n\n";
          
				cout << "\t                >> "; getline(cin,input);

				boost::to_upper(input);

				if (input != "1" && input != "2" && input != "3" && input != "EXIT")
				{
					system("CLS");
					output_file << "Please choose a valid option\n";
				}

			}while(input != "1" && input != "2" && input != "3" && input != "EXIT");

			system("CLS");
			*/
		string sequence;
		commands >> sequence;
		commands >> input;
		if (input == "Static")
			SpreadsheetCreator_STATIC(sequence);
		else if (input == "Dynamic")
		{
			SpreadsheetCreator(sequence);
		}
		//system("CLS");
	}
	/*
	else if (input == "6")
	{
		output_file << "\nMatlab not yet implemented\n";
		output_file << "Open 'animation_graphs.m' within Matlab to use this component of the program\n";
		
		system("CLS");
	}
	else if (input == "7")
	{
		system("CLS");
		//LocationGenerator(true);
		system("CLS");
	}
	else if (input == "8" || input == "EXIT")
	{
		title = false;
		system("CLS");
	}
	*/
	else
	{
		system("CLS");
		cout << "Invalid option. Please enter a value from the list:\n";
	}
                 
	//}while (title == true);
	
	system("CLS");
	cout << "Analysis finished" << endl;
	//
return 0;

}	//end main()

