//		convert.h
//		Chris Briglio

#include "stdafx.h"

#include <stdexcept>


/*
	BadConversion class:
		used to check if conversion was successfull
*/
class BadConversion : public std::runtime_error {
public:
  BadConversion(std::string const& s)
    : std::runtime_error(s)
    { }
};


/*
	convertToDouble function:
		converts given string into a variable of type double
*/
inline double convertToDouble(std::string const& s)
{
  std::istringstream i(s);
  double x;
  if (!(i >> x))
    throw BadConversion("convertToDouble(\"" + s + "\")");
  return x;
}


/*
	convertToInterger function:
		converts given string into a variable of type int
*/
inline int convertToInterger(std::string const& s)
{
  std::istringstream i(s);
  int x;
  if (!(i >> x))
    throw BadConversion("convertToDouble(\"" + s + "\")");
  return x;
}

