// stdafx.cpp : source file that includes just the standard includes
// Statistics for Dynamic Networks.pch will be the pre-compiled header
// stdafx.obj will contain the pre-compiled type information

#include "stdafx.h"

#include <sys/stat.h>

//------------------------------------------------------------------------------GLOBAL VARIABLES-------------------------------------------------------------------------------------//

//-----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------//


std::string exitmask = "";						//used to check if user wishes to exit to previous menu at any time

std::string infilename = "";					//used as name of input file at an given time

std::string filetype = "";						//used when user specifies what file type will be used (NS2/CORE/OPNET)

std::string outfilename = "";					//used as name of output file at an given time

std::string inputmode = "";						//used when user chooses between single file and multi-file Location generation 

std::string folderPath = "";					//used to specify where output folder and files will be created

std::string temp = "";							//temp string for mundane purposes

std::string extension = "";						//used to specify file extension for specific file type

int num_nodes = 0;								//used to track the number of nodes in the scenario being worked on

int txt_index = 0;								//used to track at what point in string givin sequence is found

std::ofstream output_file;

 //------------------------------------------------------------------------------GLOBAL FUNCTIONS-------------------------------------------------------------------------------------//

 //-----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------//


/*
	sqr function:
		takes a double value number and returns that values multiplied by itself
*/
double sqr(double value) { return value * value; }


/*
	checkEXT function:
		Checks if given string has proper extention fro file type by checking last 4 characters of string for proper file extension
		If capital letters makes lower case.
		Checks if not just extension by checking if length is greater than 4
*/
bool checkEXT(std::string& s)
{

	if (filetype == "OPNET")
	{

		if (s.size() < 5)
			return false;

		if (s[s.size() - 3] == 'X')
			s[s.size() - 3] = 'x';
		if (s[s.size() - 2] == 'M')
			s[s.size() - 2] = 'm';
		if (s[s.size() - 1] == 'L')
			s[s.size() - 1] = 'l';


		if (s[s.size() - 4] != '.') 
			return false;
		else if (s[s.size() - 3] != 'x')
			return false;
		else if (s[s.size() - 2] != 'm')
			return false;
		else if (s[s.size() - 1] != 'l')
			return false;
		else
			return true;
	}
	else if (filetype == "NS2")
	{
		if (s.size() < 5)
			return false;

		if (s[s.size() - 3] == 'T')
			s[s.size() - 3] = 't';
		if (s[s.size() - 2] == 'X')
			s[s.size() - 2] = 'x';
		if (s[s.size() - 1] == 'T')
			s[s.size() - 1] = 't';

		if (s[s.size() - 4] != '.') 
			return false;
		else if (s[s.size() - 3] != 't')
			return false;
		else if (s[s.size() - 2] != 'x')
			return false;
		else if (s[s.size() - 1] != 't')
			return false;
		else
			return true;
	}
	else if (filetype == "CORE")
	{
	
		if (s.size() < 5)
			return false;

		if (s[s.size() - 3] == 'I')
			s[s.size() - 3] = 'i';
		if (s[s.size() - 2] == 'M')
			s[s.size() - 2] = 'm';
		if (s[s.size() - 1] == 'N')
			s[s.size() - 1] = 'n';


		if (s[s.size() - 4] != '.') 
			return false;
		else if (s[s.size() - 3] != 'i')
			return false;
		else if (s[s.size() - 2] != 'm')
			return false;
		else if (s[s.size() - 1] != 'n')
			return false;
		else
			return true;
	}
	else
	{
		std::cout << "file type not recognized\n";
		return false;
	}

}


/*
	dirExists function:
		checks if directory exists
*/
bool dirExists(const std::string& dirName_in)
{
  DWORD ftyp = GetFileAttributesA(dirName_in.c_str());
  if (ftyp == INVALID_FILE_ATTRIBUTES)
    return false;  //something is wrong with your path!

  if (ftyp & FILE_ATTRIBUTE_DIRECTORY)
    return true;   // this is a directory!

  return false;    // this is not a directory!
}


/*
	create_folder function:
		creates output folder within input file directory.

		variables 'txt_index'  and 'infilename' must be set before calling this function
*/
void create_folder(std::string path_temp)
{

	std::string folder_path_temp = path_temp;

	folder_path_temp.append(infilename.erase(txt_index));

	infilename.append(extension);

	folder_path_temp.append(" output\\");

	folderPath.append(infilename.erase(txt_index));

	folderPath.append(" output\\");


	if (CreateDirectory(folder_path_temp.c_str(),NULL) == 0)			//check for errors ( if error, returns 0 )
	{

		if (ERROR_PATH_NOT_FOUND == GetLastError())	
		{
			std::cout << "\nError: path for folder creation not found.\n";
			
			folderPath = "";		//sets folder path to nothing so file will be written in same directory as input file
		}
		else if (ERROR_ALREADY_EXISTS == GetLastError())
		{
			std::cout << "\n" << folder_path_temp << " already exists.\nOutput file will be created within the folder.\n";
		}
	}

}


/*
	fileExists function:
		Check if a file exists
		Argument: filename - the name of the file to check
		returns true if the file exists
*/
bool fileExists(const std::string& filename)
{
    struct stat buf;
    if (stat(filename.c_str(), &buf) != -1)
    {
        return true;
    }
    return false;
}

